#include "Bateau.h"
#include <math.h>

//---------------------------------------------------------------------------
Bateau::Bateau()

{        etat.x = 0.0f;
         etat.y = 1.0f;
         etat.theta = PI/6;
         etat.v = 3.0f;
         etat.omega = 0.0f;
         etat.deltav = 0.0f;
         etat.deltag =0.0f;
         etat.gamma=0;
         etat.gammapoint=0;

         beta=0.05;J=3000.0;rg=4.0;
         alphatheta=2000.0;  m=1000.0;  alphaf=100.0;  rv=2.0;  alphag=250.0;
         l=2.0;alphav=500.0;  /*V=10.0*/;  Lr=1;  Jr=175000;  alphaR=300;  Gr=1;
         P=30000;

         cap=PI/6;
         qq=3;
         xd=250;
         yd=250;
         th=PI/6;
         

}
//---------------------------------------------------------------------------
 float Bateau::Ouverture()
 { float ouverture=PI*(floor((cap+PI/2)/(2*PI)))+PI/4-cap/2;
   return ouverture;
 }
 //--------------------------------------------------------------------------
 float Bateau::argument()
 {float k,th1;
 k=(int)((cap-th)/(2*PI));
 th1=th+2*k*PI;
 return th1;
 }
//---------------------------------------------------------------------------
float Bateau::Automate(float dT)
{  float a=12;
   float cap1;
if ((qq==3)& ((etat.x-xd)>a)&((etat.y-yd)<-a))
{qq=4;
th=5*PI/6;}
 if ((qq==4)& ((etat.x-xd)<-a)&((etat.y-yd)<-a)){
qq=3;
th=PI/6; }
if ((qq==3)&((etat.y-yd)>a)&((etat.x-xd)<-a)){
qq=1;
th=-PI/4;}
 if ((qq==1)&((etat.y-yd)<-a)&((etat.x-xd)<-a)){
qq=3;
th=PI/6;}


 if ((qq==4)&((etat.y-yd)>a)&((etat.x-xd)>a)){
qq=2;
th=-3*PI/4;}
if ((qq==2)&((etat.y-yd)<-a)&((etat.x-xd)>a)){
qq=4;
th=5*PI/6;}
if ((qq==1)&((etat.x-xd)>a)&((etat.y-yd)>a)){
qq=2;
th=-3*PI/4;}
if ((qq==2)&((etat.x-xd)<-a)&((etat.y-yd)>a)){
qq=1;
th=-PI/4; }

if ((qq==1)&((etat.x-xd)>a)&((etat.y-yd)<-a)){
qq=4;
th=5*PI/6; }
if ((qq==4)&((etat.x-xd)<-a)&((etat.y-yd)>a)){
qq=1;
th=-PI/4; }
if ((qq==3)&((etat.x-xd)>a)&((etat.y-yd)>a)){
qq=2;
th=-3*PI/6; }
if ((qq==2)&((etat.x-xd)<-a)&((etat.y-yd)<-a)){
qq=3;
th=PI/6; }
 cap1=argument();

return cap+=5*(cap1-cap)*dT;

 }                             
//---------------------------------------------------------------------------
void Bateau::Incremente(float dT,float w1,float w2)
{       V+=(random(2)-0.5);
        fv    = alphav*V*cos(etat.theta+etat.deltav)-alphav*etat.v*sin(etat.deltav);
        fg    = alphag*etat.v*sin(etat.deltag);
        etat.x          += etat.v*cos(etat.theta)*dT;
        etat.y          += (etat.v*sin(etat.theta)-beta*V)*dT;
        etat.theta      += etat.omega*dT;
        etat.omega      += (1/J)*((l-rv*cos(etat.deltav))*fv
                          -rg*cos(etat.deltag)*fg-alphatheta*etat.omega)*dT;
        u1=0.8*(w1-etat.deltav);
        u2= (1/(fg*rg*sin(etat.deltag)-etat.v*rg*alphag*cos(etat.deltag)*cos(etat.deltag)))*
            ((etat.v*l*alphav*cos(etat.deltav)-fv*rv*sin(etat.deltav)+V*l*alphav*sin(etat.theta+etat.deltav)-V*
            rv*alphav*cos(etat.deltav)*sin(etat.theta+etat.deltav)-etat.v*rv*alphav*cos(etat.deltav)*cos(etat.deltav))*
             0.8*(w1-etat.deltav)+J*(5*(w2-etat.theta)-3.5*etat.omega-3*((1/J)*((l-rv*cos(etat.deltav))*fv
                          -rg*cos(etat.deltag)*fg-alphatheta*etat.omega)))-(-(1/J)*((l-rv*cos(etat.deltav))*fv-rg*cos(etat.deltag)*fg-alphatheta*etat.omega)*
             alphatheta-rg*((1/m)*(sin(etat.deltav)*fv-sin(etat.deltag)*fg-alphaf*etat.v))*cos(etat.deltag)*sin(etat.deltag)*alphag-J*alphav*
             (((1/m)*(sin(etat.deltav)*fv-sin(etat.deltag)*fg-alphaf*etat.v))*sin(etat.deltav)+V*etat.omega*sin(etat.theta+etat.deltav))*
             (-(1/J)-(1/J)*rv*cos(etat.deltav))));
        etat.deltav     += u1*dT;
        etat.deltag     += u2*dT;
        if (etat.deltag>PI/5) {etat.deltag=PI/5;}
        if (etat.deltag<-PI/5){etat.deltag=-PI/5;}

        etat.v          += (1/m)*(sin(etat.deltav)*fv-sin(etat.deltag)*fg-alphaf*etat.v)*dT;
        etat.gamma          += etat.gammapoint*dT;//donne l'angle pour faire pancher le bateau (en fonction de la force sur la voile) en radian
        etat.gammapoint     +=(1/Jr)*(-alphaR*etat.gammapoint+Lr*fv*cos(etat.gamma)-Gr*P*sin(etat.gamma))*dT;
}

//---------------------------------------------------------------------------
void Bateau::Draw()
{

        glTranslatef(etat.x,etat.y,0);
         float c=(V+(random(2)-0.5))/3  ;  //flche vent
         glLineWidth(2);
        glBegin(GL_LINES);
                glColor3f(0,0.7,0);
                glVertex3f(3,-4,13);
                glVertex3f(3,-4-c,13);
                glVertex3f(3,-4-c,13);
                glVertex3f(3,-4-c,14);
                glVertex3f(3,-4-c,14);
                glVertex3f(3,-5.5-c,12.5);
                glVertex3f(3,-5.5-c,12.5);
                glVertex3f(3,-4-c,11);
                glVertex3f(3,-4-c,11);
                glVertex3f(3,-4-c,12);
                glVertex3f(3,-4-c,12);
                glVertex3f(3,-4,12);
                glVertex3f(3,-4,12);
                glVertex3f(3,-4,13);

        glEnd();

        glRotatef(etat.theta*RadToDeg,0,0,1);
        glRotatef(etat.gamma*RadToDeg,1,0,0);

        //coque:
        float h = 1.0f; //hauteur
         glBegin(GL_POLYGON);
                glColor3f(0,0,0);
                glVertex3f(-1,-2,0.01);  glVertex3f(4,-2,0.01); //fond noir
                glVertex3f(5,-1,0.01);   glVertex3f(5,1,0.01);
                glVertex3f(4,2,0.01);    glVertex3f(-1,2,0.01);
          glEnd();
         glBegin(GL_POLYGON);
                glColor3f(1,0,0);
                glVertex3f(-1,-2,h);  glVertex3f(4,-2,h); //dessus rouge
                glVertex3f(5,-1,h);   glVertex3f(5,1,h);
                glVertex3f(4,2,h);    glVertex3f(-1,2,h);
          glEnd();


          glBegin(GL_POLYGON); //faces latrales
                glColor3f(0,1,0);
                glNormal3f(0,-1,0);
                glVertex3f(-1,-2,0);    glVertex3f(-1,-2,h);
                glVertex3f(4,-2,h);     glVertex3f(4,-2,0);
                glVertex3f(-1,-2,0);
           glEnd();
          glBegin(GL_POLYGON);
                 glNormal3f(0,1,0);
                glVertex3f(4,2,0);      glVertex3f(4,2,h);
                glVertex3f(-1,2,h);     glVertex3f(-1,2,0);
                glVertex3f(4,2,0);
            glEnd();
          glBegin(GL_POLYGON); //face arrire
                glNormal3f(-1,0,0);
                glVertex3f(-1,-2,0);    glVertex3f(-1,-2,h);
                glVertex3f(-1,2,h);     glVertex3f(-1,2,0);
                glVertex3f(-1,-2,0);
            glEnd();
          glBegin(GL_POLYGON);//face avant
                glNormal3f(1,0,0);
                glVertex3f(5,-1,0);     glVertex3f(5,-1,h);
                glVertex3f(5,1,h);      glVertex3f(5,1,0);
                glVertex3f(5,-1,0);
            glEnd();
          glBegin(GL_POLYGON);//faces avantdiagonal
                glVertex3f(4,2,0);      glVertex3f(4,2,h);
                glVertex3f(5,1,h);     glVertex3f(5,1,0);
                glVertex3f(4,2,0);
             glEnd();
          glBegin(GL_POLYGON);
                glVertex3f(4,-2,0);      glVertex3f(4,-2,h);
                glVertex3f(5,-1,h);     glVertex3f(5,-1,0);
                glVertex3f(4,-2,0);
             glEnd();

        glPushMatrix();

            glEnable(GL_BLEND);
                                    //la couleur de l'objet va tre (1-alpha_de_l_objet) * couleur du fond et (le_reste * couleur originale)
            glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

        glTranslatef(2,0,0);                   //voile
        glRotatef(etat.deltav*RadToDeg,0,0,1);
        float a=-atan(fv/500);
        GLfloat jaune[] = {0.8f, 0.8f, 0.0f, 0.9f}; // 4me point donne la transparence

           glBegin(GL_TRIANGLE_FAN);
                  glColor4fv(jaune);  // 4 au lieu de 3 pour la transparence
                  glVertex3f(0,0,2);
                  glVertex3f(0,0,12);
                  glVertex3f(-1,a*1.5,10);
                  glVertex3f(-2,a*2,8);
                  glVertex3f(-3,a*2,6);
                  glVertex3f(-4,a*1.5,4);
                  glVertex3f(-5,0,2);
           glEnd();

           glDisable(GL_BLEND);


          glPopMatrix();

         glPushMatrix();
         glTranslatef(-1,0,0);                   //gouvernail
        glRotatef(etat.deltag*RadToDeg,0,0,1);
        glBegin(GL_POLYGON);
                glColor3f(1,0,0);
                glVertex3f(0,0,1);
                glVertex3f(0,0,0);
                glVertex3f(-2,0,0);
                glVertex3f(-1,0,1);
                glVertex3f(0,0,1);

        glEnd();
         float b=fg/300;
        glBegin(GL_LINES);                       //force gouvernail
                glColor3f(1,1,0);
                glVertex3f(-1,0,0.5);
                glVertex3f(-1,b,0.5);




        glEnd();

        glPopMatrix();

       // glPushMatrix();
        glLineWidth(4);
        glBegin(GL_LINES);              //mt
                glColor3f(0,0,0);
                glVertex3f(2,0,0);     glVertex3f(2,0,14);
        glEnd();


        }
//---------------------------------------------------------------------------

